﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

namespace FYEDrawDemo_Senior
{
    public class IFYDC
    {
        #region 浮云绘图DLL 接口
        //组件接口
        [DllImport("FYEDC.dll", EntryPoint = "NewFYEDC", CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr NewFYEDC();
        [DllImport("FYEDC.dll", EntryPoint = "CreateFYEDC", CallingConvention = CallingConvention.Cdecl)]
        public static extern void CreateFYEDC(IntPtr canvas, IntPtr hParentWnd, int x, int y, int w, int h);
        [DllImport("FYEDC.dll", EntryPoint = "LoadShapes", CallingConvention = CallingConvention.Cdecl)]
        public static extern void LoadShapes(IntPtr canvas, string fileName);
        [DllImport("FYEDC.dll", EntryPoint = "DeleteFYEDC", CallingConvention = CallingConvention.Cdecl)]
        public static extern void DeleteFYEDC(IntPtr canvas);

        // 图元对象
        [DllImport("FYEDC.dll", EntryPoint = "GetShapeCount", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetShapeCount(IntPtr canvas);

        [DllImport("FYEDC.dll", EntryPoint = "GetShape", CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr GetShape(IntPtr canvas, string type, string name);
        [DllImport("FYEDC.dll", EntryPoint = "GetShapeAt", CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr GetShapeAt(IntPtr canvas, int index);

        [DllImport("FYEDC.dll", EntryPoint = "GetmCompElementCount", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetmCompElementCount(IntPtr editor, string type, string name);
        [DllImport("FYEDC.dll", EntryPoint = "GetCompElement", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetCompElement(ref IntPtr diagrams, IntPtr editor, string type, string name);

        [DllImport("FYEDC.dll", EntryPoint = "GetShapeTypeCount", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetShapeTypeCount(IntPtr canvas, string type);
        [DllImport("FYEDC.dll", EntryPoint = "GetShapeTitleCount", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetShapeTitleCount(IntPtr canvas, string title);
        [DllImport("FYEDC.dll", EntryPoint = "GetShapeNameCount", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetShapeNameCount(IntPtr canvas, string name);

        // 图元属性
        [DllImport("FYEDC.dll", EntryPoint = "GetShapeType", CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetShapeType(IntPtr shape, ref byte type);
        [DllImport("FYEDC.dll", EntryPoint = "GetShapeTitle", CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetShapeTitle(IntPtr shape, ref byte title);
        [DllImport("FYEDC.dll", EntryPoint = "SetShapeTitle", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetShapeTitle(IntPtr canvas, IntPtr shape, string title);
        [DllImport("FYEDC.dll", EntryPoint = "GetShapeName", CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetShapeName(IntPtr shape, ref byte type);
        [DllImport("FYEDC.dll", EntryPoint = "SetShapeName", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetShapeName(IntPtr canvas, IntPtr shape, string name);

        [DllImport("FYEDC.dll", EntryPoint = "GetShapeGroupId", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetShapeGroupId(IntPtr shape);

        [DllImport("FYEDC.dll", EntryPoint = "SetBackColor", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetBackColor(IntPtr canvas, int color);
        [DllImport("FYEDC.dll", EntryPoint = "GetBackColor", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetBackColor(IntPtr canvas);
        [DllImport("FYEDC.dll", EntryPoint = "SetNoClientColor", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetNoClientColor(IntPtr canvas, int color);

        [DllImport("FYEDC.dll", EntryPoint = "SetLineColor", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetLineColor(IntPtr canvas, IntPtr shape, int color);
        [DllImport("FYEDC.dll", EntryPoint = "GetLineColor", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetLineColor(IntPtr shape);

        [DllImport("FYEDC.dll", EntryPoint = "SetLineStyle", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetLineStyle(IntPtr canvas, IntPtr shape, int style);
        [DllImport("FYEDC.dll", EntryPoint = "GetLineStyle", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetLineStyle(IntPtr shape);

        [DllImport("FYEDC.dll", EntryPoint = "SetLineWidth", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetLineWidth(IntPtr canvas, IntPtr shape, int width);
        [DllImport("FYEDC.dll", EntryPoint = "GetLineWidth", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetLineWidth(IntPtr shape);

        [DllImport("FYEDC.dll", EntryPoint = "SetLineEndMode", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetLineEndMode(IntPtr canvas, IntPtr shape, int mode);
        [DllImport("FYEDC.dll", EntryPoint = "GetLineEndMode", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetLineEndMode(IntPtr shape);

        [DllImport("FYEDC.dll", EntryPoint = "SetFillColor", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetFillColor(IntPtr canvas, IntPtr shape, int color);
        [DllImport("FYEDC.dll", EntryPoint = "GetFillColor", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetFillColor(IntPtr shape);

        [DllImport("FYEDC.dll", EntryPoint = "SetIsFill", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetIsFill(IntPtr canvas, IntPtr shape, int isFill);
        [DllImport("FYEDC.dll", EntryPoint = "GetIsFill", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetIsFill(IntPtr shape);

        [DllImport("FYEDC.dll", EntryPoint = "SetFontColor", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetFontColor(IntPtr canvas, IntPtr shape, int color);
        [DllImport("FYEDC.dll", EntryPoint = "GetFontColor", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetFontColor(IntPtr shape);
        [DllImport("FYEDC.dll", EntryPoint = "SetFontType", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetFontType(IntPtr canvas, IntPtr shape, string type);
        [DllImport("FYEDC.dll", EntryPoint = "GetFontType", CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetFontType(IntPtr shape, ref byte type);
        [DllImport("FYEDC.dll", EntryPoint = "SetFontSize", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetFontSize(IntPtr canvas, IntPtr shape, int size);
        [DllImport("FYEDC.dll", EntryPoint = "GetFontSize", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetFontSize(IntPtr shape);

        [DllImport("FYEDC.dll", EntryPoint = "SetShapeText", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetShapeText(IntPtr canvas, IntPtr shape, string text);
        [DllImport("FYEDC.dll", EntryPoint = "GetShapeText", CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetShapeText(IntPtr shape, ref byte text);
        [DllImport("FYEDC.dll", EntryPoint = "SetTextVisible", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetTextVisible(IntPtr canvas, IntPtr shape, int isShow);
        [DllImport("FYEDC.dll", EntryPoint = "GetTextVisible", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetTextVisible(IntPtr shape);

        [DllImport("FYEDC.dll", EntryPoint = "GetImageStatus", CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetImageStatus(IntPtr shape);
        [DllImport("FYEDC.dll", EntryPoint = "SetImageStatus", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetImageStatus(IntPtr canvas, IntPtr shape, int status);

        // 区域
        [DllImport("FYEDC.dll", EntryPoint = "SetCanvasRect", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetCanvasRect(IntPtr canvas, int left, int top, int right, int bottom);
        [DllImport("FYEDC.dll", EntryPoint = "GetCanvasRect", CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetCanvasRect(IntPtr canvas, ref int left, ref int top, ref int right, ref int bottom);
        [DllImport("FYEDC.dll", EntryPoint = "SetVirtualSize", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetVirtualSize(IntPtr canvas, int widht, int height);
        [DllImport("FYEDC.dll", EntryPoint = "GetVirtualSize", CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetVirtualSize(IntPtr canvas, ref int width, ref int height);

        // 缩放
        [DllImport("FYEDC.dll", EntryPoint = "SetZoom", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetZoom(IntPtr canvas, double zoom);
        [DllImport("FYEDC.dll", EntryPoint = "GetZoom", CallingConvention = CallingConvention.Cdecl)]
        public static extern double GetZoom(IntPtr canvas);
        [DllImport("FYEDC.dll", EntryPoint = "SetZoomFactor", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetZoomFactor(IntPtr canvas, double factor);
        [DllImport("FYEDC.dll", EntryPoint = "GetZoomFactor", CallingConvention = CallingConvention.Cdecl)]
        public static extern double GetZoomFactor(IntPtr canvas);

        // 网格
        [DllImport("FYEDC.dll", EntryPoint = "SetGridShow", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetGridShow(IntPtr canvas, int bShow);

        // 可编辑模式 0不可编辑 1可编辑
        [DllImport("FYEDC.dll", EntryPoint = "SetEditMode", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetEditMode(IntPtr canvas, int bEdit);

        // 设置接收鼠标消息的窗口
        [DllImport("FYEDC.dll", EntryPoint = "SetRcvMsgWnd", CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetRcvMsgWnd(IntPtr canvas, IntPtr pRcvMsgWnd);

        // 存为图片
        [DllImport("FYEDC.dll", EntryPoint = "SaveToPicture", CallingConvention = CallingConvention.Cdecl)]
        public static extern int SaveToPicture(IntPtr canvas, string fileName);
        #endregion 浮云绘图DLL 接口
    }

    public enum EnShapeType : int
    {
        Unknow = 0,             // 未知类型
        Line = 1,               // 直线
        Rectangle = 2,          // 矩形（正方形）
        Ellipse = 3,            // 椭圆（圆）
        Text = 4,               // 文本
        Image = 5,              // 图片
        MultPointLine = 6,      // 多点线
        Triangle = 7,           // 三角形
        Quadrilate = 8,         // 四角形
        Sector = 9,             // 扇形
        Group = 100             // 复合图元   （复合图元支持，请参考浮云绘图高级Demo工程）
    }

    public class ShapeElement
    {
        public ShapeElement(IntPtr handle, EnShapeType enDType)
        {
            Handle = handle;
            ShapeType = enDType;
        }

        public IntPtr Handle { get; set; }      // 物理图元对象（绘图编辑器画的图元）内存指针

        public EnShapeType ShapeType { get; set; }

        public String Title { get; set; }

        public String Name { get; set; }

        public String Text { get; set; }

        public int Index { get; set; }      //（绘图编辑器画的图元）数据文件的图元顺序号

        public int Group { get; set; }      // 组号（同一个复合图元里的子基础图元组号相等）

        public bool Visible { get; set; }

        public int Status { get; set; }     // 业务图元的上次状态

        public object Tag { get; set; }     // 业务对象
    }

    public class ShapeCompElement: ShapeElement
    {
        public List<ShapeElement> Elements { get; set; }

        public ShapeCompElement(IntPtr handle, EnShapeType enType) : base(handle, enType)
        {
            Elements = new List<ShapeElement>();
        }

        public void AddElement(ShapeElement element)
        {
            Elements.Add(element);
        }

        public void Remove(ShapeElement element)
        {
            Elements.Remove(element);
        }

        public int GetCount()
        {
            return Elements.Count;
        }

        public void Clear()
        {
            Elements?.Clear();
        }
    }

    // 浮云绘图（物理图元<->逻辑图元）类
    // 注意：本类支持复合图元
    public class FYECMDCView
    {
        private IntPtr hShapeCanvas = IntPtr.Zero;
        private Panel panel = null;
        private List<ShapeElement> shapeElementList;

        public void Create(Panel panel)
        {
            this.panel = panel;
            hShapeCanvas = IFYDC.NewFYEDC();
            IFYDC.CreateFYEDC(hShapeCanvas, panel.Handle,0,0, panel.Width, panel.Height);
        }
        public void Release()
        { 
            if(hShapeCanvas != null)
            {
                foreach(ShapeElement shape in shapeElementList)
                {
                    if(shape is ShapeCompElement comp)
                    {
                        comp?.Clear();
                    }
                }

                shapeElementList.Clear();
                IFYDC.DeleteFYEDC(hShapeCanvas);
                hShapeCanvas = IntPtr.Zero;
            }
        }
        public bool Open(String fileName)
        {
            IFYDC.LoadShapes(hShapeCanvas, fileName);

            int virBackColor = IFYDC.GetBackColor(hShapeCanvas);
            IFYDC.SetNoClientColor(hShapeCanvas, virBackColor);

            return true;
        }

        byte[] bys = new byte[200];
        public void Load()
        {
            shapeElementList = new List<ShapeElement>();
            int count = IFYDC.GetShapeCount(hShapeCanvas);
            if (count <= 0) return;

            ShapeElement shape;
            ShapeCompElement comp = null;
            int curGroup = -1;
            for (int i = 0; i < count; i++)
            {
                IntPtr obj = IFYDC.GetShapeAt(hShapeCanvas, i);

                Array.Clear(bys, 0, bys.Length);
                lock (bys)
                {
                    IFYDC.GetShapeType(obj, ref bys[0]);
                }
                String sType = ByteToString(bys);

                Array.Clear(bys, 0, bys.Length);
                lock (bys)
                {
                    IFYDC.GetShapeTitle(obj, ref bys[0]);
                }
                String sTitle = ByteToString(bys);

                Array.Clear(bys, 0, bys.Length);
                lock (bys)
                {
                    IFYDC.GetShapeName(obj, ref bys[0]);
                }
                String sName = ByteToString(bys);

                Array.Clear(bys, 0, bys.Length);
                lock (bys)
                {
                    IFYDC.GetShapeText(obj, ref bys[0]);
                }
                String sText = ByteToString(bys);

                int groupId = IFYDC.GetShapeGroupId(obj);

                // 创建上层图元对象
                EnShapeType enType = GetDiagramEnType(sType);
                shape = new ShapeElement(obj, enType);
                shape.Handle = obj;
                shape.ShapeType = enType;
                shape.Title = sTitle;
                shape.Name = sName;
                shape.Text = sText;
                shape.Group = groupId;
                shape.Index = i;

                if(groupId <=0)  //基础图元
                {
                    shapeElementList.Add(shape);
                }
                else  //复合图元成员
                {
                    if (curGroup != groupId)     // 新复合图元来了
                    {
                        enType = EnShapeType.Group;
                        comp = new ShapeCompElement(obj, enType);
                        comp.ShapeType = enType;
                        comp.Title = sTitle;
                        comp.Name = sName;
                        comp.Text = sText;
                        comp.Group = groupId;
                        shapeElementList.Add(comp);

                        comp.AddElement(shape);  // 新增复合图元组中的第一个单一图元
                        curGroup = groupId;
                    }
                    else    // 同一组复合图元成员
                    {
                        if (comp != null && shape.Group == comp.Group)
                        {
                            //跳过复合图元的最后一个（仅仅为了基准，是隐藏的）矩形
                            IntPtr nextObj = IFYDC.GetShapeAt(hShapeCanvas, i + 1);
                            if(nextObj != IntPtr.Zero)  //复合图元本不是绘图配置文件里的最后一个图元
                            {
                                Array.Clear(bys, 0, bys.Length);
                                lock (bys)
                                {
                                    IFYDC.GetShapeType(nextObj, ref bys[0]);
                                }
                                String nextType = ByteToString(bys);
                                int nextGroupId = IFYDC.GetShapeGroupId(nextObj);

                                // 复合图元里的最后一个图元
                                if (nextGroupId != comp.Group && sType == "rectangle")
                                    continue;   //跳过，不加载复合图元的最后一个隐藏的矩形图元
                            }
                            else   //复合图元本是绘图配置文件里的最后一个图元
                            {
                                if (sType == "rectangle")   
                                    continue;
                            }

                            comp.AddElement(shape);
                        }

                    }
                }
            }

        }

        public void SetRect(int w, int h)
        {
            IFYDC.SetCanvasRect(hShapeCanvas, 0, 0, w, h);
        }
        public void FitParentRect()
        { 
            if(this.panel != null)
            {
                int virHeight = 0;
                int virWidth = 0;

                IFYDC.GetVirtualSize(hShapeCanvas, ref virWidth, ref virHeight);

                float xScale = this.panel.Width * 1.0F / virWidth;
                float yScale = this.panel.Height * 1.0F / virHeight;
                float scale = xScale < yScale ? xScale : yScale;

                IFYDC.SetZoom(hShapeCanvas, scale);
            }
        }

        public ShapeElement GetShape(int shapeElementIndex)
        {// 从逻辑图元列表shapeElementList返回逻辑图元
            if (shapeElementIndex < 0 || shapeElementIndex >= shapeElementList.Count)
                return null;

            return shapeElementList[shapeElementIndex];
        }
        public ShapeElement GetShapeFromPhysicalIndex(int physicalIndex)
        {
            for (int i = 0; i < shapeElementList.Count; i++)
            {
                ShapeElement element = shapeElementList[i];
                if (element.ShapeType != EnShapeType.Group)  //单一图元
                {
                    if (element.Index == physicalIndex)
                    {
                        return element;
                    }
                }
                else    //复合图元
                {
                    ShapeCompElement compElement = element as ShapeCompElement;
                    for (int j = 0; j < compElement.GetCount(); j++)
                    {
                        ShapeElement subShape = compElement.Elements[i];
                        if (subShape.Index == physicalIndex)
                        {
                            return compElement;
                        }
                    }
                }
            }

            return null;
        }

        public List<ShapeElement> GetShapeList()
        {
            return shapeElementList;
        }
        public int GetShapeCount()
        {
            return shapeElementList.Count;
        }       

        public void SetLineColor(ShapeElement element, int nColor)
        {
            if(element.ShapeType != EnShapeType.Unknow && element.ShapeType != EnShapeType.Group)
            {//单一基础图元
                IFYDC.SetLineColor(hShapeCanvas, element.Handle, nColor);
            }
            else if(element.ShapeType == EnShapeType.Group)
            {//复合图元
                ShapeCompElement comp = element as ShapeCompElement;
                foreach (ShapeElement sub in comp.Elements)
                {
                    IFYDC.SetLineColor(hShapeCanvas, sub.Handle, nColor);
                }
            }
        }
        public void SetLineStyle(ShapeElement element, int style)
        {// 0普通实线 1-- 2··  5无  9抗锯齿实线
            
            if (element.ShapeType != EnShapeType.Unknow && element.ShapeType != EnShapeType.Group)
            {//单一基础图元
                IFYDC.SetLineStyle(hShapeCanvas, element.Handle, style);
            }
            else if (element.ShapeType == EnShapeType.Group)
            {//复合图元
                ShapeCompElement comp = element as ShapeCompElement;
                foreach (ShapeElement sub in comp.Elements)
                {
                    IFYDC.SetLineStyle(hShapeCanvas, sub.Handle, style);
                }
            }
        }
        public void SetLineEndMode(ShapeElement element, int mode)
        {// 0无 11起点○ 12终端○ 13两端○  21起点● 22终端● 23两端●  
         // 31起点← 32终端← 33两端←
            
            if (element.ShapeType == EnShapeType.Line || element.ShapeType == EnShapeType.MultPointLine)
            {//单一基础图元
                IFYDC.SetLineEndMode(hShapeCanvas, element.Handle, mode);
            }
            else if (element.ShapeType == EnShapeType.Group)
            {//复合图元
                ShapeCompElement comp = element as ShapeCompElement;
                foreach (ShapeElement sub in comp.Elements)
                {
                    if (sub.ShapeType == EnShapeType.Line || sub.ShapeType == EnShapeType.MultPointLine)
                    {//单一基础图元
                        IFYDC.SetLineEndMode(hShapeCanvas, sub.Handle, mode);
                    }
                }
            }
        }
        public void SetLineWidth(ShapeElement element, int width)
        {
            if (element.ShapeType != EnShapeType.Unknow && element.ShapeType != EnShapeType.Group)
            {//单一基础图元
                IFYDC.SetLineWidth(hShapeCanvas, element.Handle, width);
            }
            else if (element.ShapeType == EnShapeType.Group)
            {//复合图元
                ShapeCompElement comp = element as ShapeCompElement;
                foreach (ShapeElement sub in comp.Elements)
                {
                    IFYDC.SetLineWidth(hShapeCanvas, sub.Handle, width);
                }
            }

        }
        public int GetLineWidth(ShapeElement element)
        {
            if (element.ShapeType == EnShapeType.Line || element.ShapeType == EnShapeType.MultPointLine)
            {//单一基础图元
                return IFYDC.GetLineWidth(element.Handle);
            }
            return 0;
        }

        public void SetFillColor(ShapeElement element, int nColor)
        {
            
            if (element.ShapeType != EnShapeType.Unknow && element.ShapeType != EnShapeType.Group)
            {//单一基础图元
                IFYDC.SetFillColor(hShapeCanvas, element.Handle, nColor);
            }
            else if (element.ShapeType == EnShapeType.Group)
            {//复合图元
                ShapeCompElement comp = element as ShapeCompElement;
                foreach (ShapeElement sub in comp.Elements)
                {
                    IFYDC.SetFillColor(hShapeCanvas, sub.Handle, nColor);
                }
            }
        }
        public void SetIsFill(ShapeElement element, int fillStyle)
        {
            
            if (element.ShapeType != EnShapeType.Unknow && element.ShapeType != EnShapeType.Group)
            {//单一基础图元
                IFYDC.SetIsFill(hShapeCanvas, element.Handle, fillStyle);
            }
            else if (element.ShapeType == EnShapeType.Group)
            {//复合图元
                ShapeCompElement comp = element as ShapeCompElement;
                foreach (ShapeElement sub in comp.Elements)
                {
                    IFYDC.SetIsFill(hShapeCanvas, sub.Handle, fillStyle);
                }
            }
        }

        public void SetText(ShapeElement element, string text)
        {
            
            if (element.ShapeType != EnShapeType.Unknow && element.ShapeType != EnShapeType.Group)
            {//单一基础图元
                IFYDC.SetShapeText(hShapeCanvas, element.Handle, text);
            }
            else if (element.ShapeType == EnShapeType.Group)
            {//复合图元
                ShapeCompElement comp = element as ShapeCompElement;
                foreach (ShapeElement sub in comp.Elements)
                {
                    IFYDC.SetShapeText(hShapeCanvas, sub.Handle, text);
                }
            }
        }
        public void SetTextVisible(ShapeElement element, int isShow)
        {
            
            if (element.ShapeType != EnShapeType.Unknow && element.ShapeType != EnShapeType.Group)
            {//单一基础图元
                IFYDC.SetTextVisible(hShapeCanvas, element.Handle, isShow);
            }
            else if (element.ShapeType == EnShapeType.Group)
            {//复合图元
                ShapeCompElement comp = element as ShapeCompElement;
                foreach (ShapeElement sub in comp.Elements)
                {
                    IFYDC.SetTextVisible(hShapeCanvas, sub.Handle, isShow);
                }
            }
        }      

        public void SetFontColor(ShapeElement element, int nColor)
        {
            
            if (element.ShapeType != EnShapeType.Unknow && element.ShapeType != EnShapeType.Group)
            {//单一基础图元
                IFYDC.SetFontColor(hShapeCanvas, element.Handle, nColor);
            }
            else if (element.ShapeType == EnShapeType.Group)
            {//复合图元
                ShapeCompElement comp = element as ShapeCompElement;
                foreach (ShapeElement sub in comp.Elements)
                {
                    IFYDC.SetFontColor(hShapeCanvas, sub.Handle, nColor);
                }
            }
        }

        public void SetImgStatus(ShapeElement element, int val)
        {
            if (element.ShapeType == EnShapeType.Image)
            {//单一基础图元
                IFYDC.SetImageStatus(hShapeCanvas, element.Handle, val);
            }
        }

        public void SetBackColor(int color)
        {
            IFYDC.SetBackColor(hShapeCanvas, color);
        }
        public int GetBackColor()
        {
            return IFYDC.GetBackColor(hShapeCanvas);
        }
        public void SetNoClientColor(int color)
        {
            IFYDC.SetNoClientColor(hShapeCanvas, color);
        }

        public void SetZoom(double zoom)
        {
            IFYDC.SetZoom(hShapeCanvas, zoom);
        }
        public double GetZoom()
        {
            return IFYDC.GetZoom(hShapeCanvas);
        }
        public void SetZoomFactor(double factor)
        {
            IFYDC.SetZoomFactor(hShapeCanvas, factor);
        }

        public void ExportFile(String fileName)
        {
            IFYDC.SaveToPicture(this.hShapeCanvas, fileName);
        }

        public void SetEditMode(bool bEdit)
        {
            IFYDC.SetEditMode(hShapeCanvas, bEdit ? 1 : 0);
        }

        public void SetRcvMsgWnd(Control ctrl)
        {
            IFYDC.SetRcvMsgWnd(hShapeCanvas, ctrl.Handle);
        }

        //public void SetRcvMsgWnd(Control ctrl)
        //{
        //    IFYDC.SetRcvMsgWnd(hShapeCanvas, ctrl.Handle);
        //}

        private static string ByteToString(byte[] s1)
        {
            //    string sType = System.Text.Encoding.Default.GetString(s1, 0, s1.Length);
            string sType = System.Text.Encoding.Unicode.GetString(s1, 0, s1.Length);
            sType = sType.Substring(0, sType.IndexOf('\0'));
            return sType;
        }

        public EnShapeType GetDiagramEnType(String type)
        {
            EnShapeType enType = EnShapeType.Unknow;

            if (type == "line") enType = EnShapeType.Line;
            else if (type == "multpointline") enType = EnShapeType.MultPointLine;
            else if (type == "rectangle") enType = EnShapeType.Rectangle;
            else if (type == "ellipse") enType = EnShapeType.Ellipse;
            else if (type == "triangle") enType = EnShapeType.Triangle;
            else if (type == "quadrilate") enType = EnShapeType.Quadrilate;
            else if (type == "sector") enType = EnShapeType.Sector;
            else if (type == "text") enType = EnShapeType.Text;
            else if (type == "image") enType = EnShapeType.Image;

            return enType;
        }
    }
}
